<?php
function sbmr($txa) {
  return preg_replace_callback('/^[^\n]*$/mu', function($matches) {
    return ' '.trim($matches[0]);
  }, $txa);
}

function txta_dsl($dafnam, $txa, $wcnt) {
  $txa = str_replace("\r", '', $txa);

  $txar = preg_split('/\n\s/', $txa, 2, PREG_SPLIT_NO_EMPTY);
  if(count($txar) == 2) {
    $txa = preg_replace('/[ ]{2,}/u', ' ', trim(str_replace("\n",' ',$txar[0])))."\n".sbmr($txar[1]);
  } else {
    if($dafnam == 'dabkrs' || $dafnam == 'dabkrss') {
      $txa = '@err'.$wcnt."\n".' _'."\n".sbmr($txa);
    } else if($dafnam == 'dabruks' || $dafnam == 'examples') {
      $txa = '@err'.$wcnt."\n".sbmr($txa);
    }
  }

  if($dafnam == 'dabkrss') {
    if(preg_match("/\n[\s]*_[\s]*\n/", $txa) == 1) {
      return '';
    }
  }

  return $txa."\n";
}

function convert_dsl($dadir, $dafnam, $profdicarr, $dictitle, $dicdescr, $dadate, $testfl) {
$dsl_dir = 'DSL';
if(!is_dir($dsl_dir)) mkdir($dsl_dir);
$ddir = $dsl_dir.'/'.$dafnam;
if(is_dir($ddir)) rrmdir($ddir);
mkdir($ddir);

$wordcountall = 0;
$wordcount = 0;
$partcount = 1;
$wipcount = 0;

$lngindex = $GLOBALS['dsl_cn_langindex'];
$lngcontent = $GLOBALS['dsl_cn_langcontent'];
if(count($profdicarr) == 1) {
  $dada = array_flip($profdicarr)[0];
  if($dada == 'dabkrs' || $dada == 'dabkrss' || $dada == 'examples') {
    $lngcontent = $GLOBALS['dsl_ru_langcontent'];
  } else if($dada == 'dabruks') {
    $lngindex = $GLOBALS['dsl_ru_langindex'];
  }
}

$dslhead = '#NAME "'.$dictitle.'@@p@@"
#INDEX_LANGUAGE "'.$lngindex.'"
#CONTENTS_LANGUAGE "'.$lngcontent.'"';

$fntmpdsl = $ddir.'/~dsl.tmp';
$hxdslwrite = fopen($fntmpdsl, 'a');

$fnxdsl = '';
foreach ($profdicarr as $dakey => $val) {
  $fnamerd = $dadir.$dakey.'_'.$dadate;
  if($dakey == 'dabkrss') {
    $fnamerd = str_replace('dabkrss', 'dabkrs', $fnamerd);
  }
  $fp = @fopen($fnamerd, 'r');
  if(!$fp) return 'err:'.$fnamerd;
  $lbuf = '';
  $wordc = 1;
  fgsit($fp, $dakey);
  while (true) {
    $buffer = fgets($fp);
    if($buffer == "\r\n" || $buffer == "\n" || $buffer === false) {
      if($buffer === false && $lbuf == '') break;
      $lbuf = trim($lbuf);
      if($lbuf == '') continue;
      ++$wordcountall;
      $xtx = txta_dsl($dakey, $lbuf, $wordcountall);
      if($xtx == '') {
        $lbuf = '';
        continue;
      }
      fwrite($hxdslwrite, iconv('UTF-8','UTF-16LE//IGNORE',$xtx));
      ++$wipcount;
      if($wipcount == $GLOBALS['dsl_numwordsinpart']) {
        $wipcount = 0;
        fclose($hxdslwrite);
        ++$partcount;
        $fnxdsl = $ddir.'/'.$dafnam.'_'.$partcount.'.dsl';
        $hxdslwrite = fopen($fnxdsl, 'a');
        fwrite($hxdslwrite, "\xFF\xFE".iconv('UTF-8','UTF-16LE//IGNORE',str_replace('@@p@@',' ( '.$partcount.' )',$dslhead."\n\n")));
      }
      ++$wordcount;
      $lbuf = '';
      if($testfl) {
        if($wordc >= $GLOBALS['tstnums']) break;
        else ++$wordc;
      }
    } else $lbuf .= $buffer;
  }
  fclose($fp);
}
fclose($hxdslwrite);
if($wipcount == 0 && $partcount > 1) {
  @unlink($fnxdsl);
  --$partcount;
}

for ($i = 1; $i <= $partcount; $i++) {
  $fnann = $ddir.'/'.$dafnam.'_'.$i.'.ann';
  $hannwrite = fopen($fnann, 'a');
  fwrite($hannwrite, "\xFF\xFE".iconv('UTF-8','UTF-16LE//IGNORE',$dicdescr));
  fclose($hannwrite);

  $fnicodsl = $ddir.'/'.$dafnam.'_'.$i.'.bmp';
  @copy('dsx/dsl_icon.bmp', $fnicodsl);
}

$fnxdsl = '';
$fntdsl = '';
if($partcount == 1) {
  rename($ddir.'/'.$dafnam.'_1.ann', $ddir.'/'.$dafnam.'.ann');
  rename($ddir.'/'.$dafnam.'_1.bmp', $ddir.'/'.$dafnam.'.bmp');
  $fnxdsl = $ddir.'/'.$dafnam.'.dsl';
} else {
  for ($i = 1; $i <= $partcount; $i++) {
    $fnann = $ddir.'/'.$dafnam.'_'.$i.'.ann';
    $hannwrite = fopen($fnann, 'a');
    fwrite($hannwrite, iconv('UTF-8','UTF-16LE//IGNORE',"\n".'Часть '.$i.' из '.$partcount));
    fclose($hannwrite);
  }
  $fnxdsl = $ddir.'/'.$dafnam.'_1.dsl';
  $fntdsl = ' ( 1 / '.$partcount.' )';
}

$hxdslwrite = fopen($fnxdsl, 'a');
fwrite($hxdslwrite, "\xFF\xFE".iconv('UTF-8','UTF-16LE//IGNORE',str_replace('@@p@@',$fntdsl,$dslhead)));
if($GLOBALS['dsl_include']) for ($i = 2; $i <= $partcount; $i++) fwrite($hxdslwrite, iconv('UTF-8','UTF-16LE//IGNORE',"\n".'#INCLUDE "'.$dafnam.'_'.$i.'.dsl"'));
fwrite($hxdslwrite, iconv('UTF-8','UTF-16LE//IGNORE',"\n\n"));

$ftmpsz = filesize($fntmpdsl);
$htmprd = fopen($fntmpdsl, 'r');
$frwlen = 102400;
for( ; ; ) {
  if($ftmpsz > $frwlen) {
    fwrite($hxdslwrite, fread($htmprd, $frwlen), $frwlen);
    $ftmpsz -= $frwlen;
  } else {
    fwrite($hxdslwrite, fread($htmprd, $ftmpsz), $ftmpsz);
    break;
  }
}
fclose($htmprd);
fclose($hxdslwrite);
unlink($fntmpdsl);

zipc($ddir);
return restfunc($dafnam, $wordcount, $wordcountall);
}
?>